schema = {'info': {'title': 'Cog', 'version': '0.1.0'}, 'paths': {'/': {'get': {'summary': 'Root', 'responses': {'200': {'content': {'application/json': {'schema': {}}}, 'description': 'Successful Response'}}, 'operationId': 'root__get'}}, '/predictions': {'post': {'summary': 'Predict', 'responses': {'200': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/Response'}}}, 'description': 'Successful Response'}, '422': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/HTTPValidationError'}}}, 'description': 'Validation Error'}}, 'description': 'Run a single prediction on the model', 'operationId': 'predict_predictions_post', 'requestBody': {'content': {'application/json': {'schema': {'$ref': '#/components/schemas/Request'}}}}}}}, 'openapi': '3.0.2', 'components': {'schemas': {'Input': {'type': 'object', 'title': 'Input', 'properties': {'seed': {'type': 'integer', 'title': 'Seed', 'x-order': 5, 'description': 'The seed (for reproducible sampling).'}, 'scale': {'type': 'number', 'title': 'Scale', 'default': 7.5, 'x-order': 3, 'description': 'Unconditional guidance scale: eps = eps(x, empty) + scale * (eps(x, cond) - eps(x, empty)).'}, 'steps': {'type': 'integer', 'title': 'Steps', 'default': 50, 'x-order': 4, 'description': 'Number of sampling steps.'}, 'prompt': {'type': 'string', 'title': 'Prompt', 'default': 'female cyborg assimilated by alien fungus, intricate Three-point lighting portrait, by Ching Yeh and Greg Rutkowski, detailed cyberpunk in the style of GitS 1995', 'x-order': 0, 'description': 'The prompt to render.'}, 'ori_width': {'allOf': [{'$ref': '#/components/schemas/ori_width'}], 'default': 512, 'x-order': 1, 'description': 'Width of original stable-diffusion output image. Final output will double the width. Note that 1024x1024 may run out of memory, if so, please lower the width or height.'}, 'ori_height': {'allOf': [{'$ref': '#/components/schemas/ori_height'}], 'default': 512, 'x-order': 2, 'description': 'Height of original stable-diffusion output image. Final output will double the height. Note that 1024x1024 may run out of memory, if so, please lower the width or height.'}}}, 'Output': {'type': 'string', 'title': 'Output', 'format': 'uri'}, 'Status': {'enum': ['processing', 'succeeded', 'failed'], 'type': 'string', 'title': 'Status', 'description': 'An enumeration.'}, 'Request': {'type': 'object', 'title': 'Request', 'properties': {'input': {'$ref': '#/components/schemas/Input'}, 'output_file_prefix': {'type': 'string', 'title': 'Output File Prefix'}}, 'description': 'The request body for a prediction'}, 'Response': {'type': 'object', 'title': 'Response', 'required': ['status'], 'properties': {'error': {'type': 'string', 'title': 'Error'}, 'output': {'$ref': '#/components/schemas/Output'}, 'status': {'$ref': '#/components/schemas/Status'}}, 'description': 'The response body for a prediction'}, 'ori_width': {'enum': [128, 256, 512, 768, 1024], 'type': 'integer', 'title': 'ori_width', 'description': 'An enumeration.'}, 'ori_height': {'enum': [128, 256, 512, 768, 1024], 'type': 'integer', 'title': 'ori_height', 'description': 'An enumeration.'}, 'ValidationError': {'type': 'object', 'title': 'ValidationError', 'required': ['loc', 'msg', 'type'], 'properties': {'loc': {'type': 'array', 'items': {'anyOf': [{'type': 'string'}, {'type': 'integer'}]}, 'title': 'Location'}, 'msg': {'type': 'string', 'title': 'Message'}, 'type': {'type': 'string', 'title': 'Error Type'}}}, 'HTTPValidationError': {'type': 'object', 'title': 'HTTPValidationError', 'properties': {'detail': {'type': 'array', 'items': {'$ref': '#/components/schemas/ValidationError'}, 'title': 'Detail'}}}}}}